import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import javax.microedition.io.Connector;

import com.nttdocomo.ui.Display;

public class Config {
	public static int pad1A = (1 << Display.KEY_3);
	public static int pad1B = (1 << Display.KEY_2);
	public static int pad1Select = (1 << Display.KEY_5);
	public static int pad1Start = (1 << Display.KEY_6);
	public static int pad1Up = (1 << Display.KEY_UP);
	public static int pad1Down = (1 << Display.KEY_DOWN);
	public static int pad1Left = (1 << Display.KEY_LEFT);
	public static int pad1Right = (1 << Display.KEY_RIGHT);
	public static int keyStateSave = (1 << Display.KEY_1);
	public static int keyStateLoad = (1 << Display.KEY_4);	
	public static int keyUp = (1 << Display.KEY_UP);
	public static int keyDown = (1 << Display.KEY_DOWN);
	public static int keyOK = (1 << Display.KEY_SELECT);
	public static int keyCancel = (1 << Display.KEY_LEFT);
	public static int keyMenu = (1 << Display.KEY_SOFT1);
	public static int frameSkip = 0;
	public static boolean sleepEnable = true;
	public static boolean vSyncWaitEnable = false;
	public static boolean dispFPSEnable = false;	
	public static int APUMode = 0;
	public static int APUVolume = 100;
	public static int APUBuffer = 15;
	public static boolean APUEnable = true;
	public static boolean APUStereoEnable = true;
		
	public static void setupKeysHorizontial()
	{
		pad1A = (1 << Display.KEY_0);
		pad1B = (1 << Display.KEY_8);
		pad1Select = (1 << Display.KEY_2);
		pad1Start = (1 << Display.KEY_5);
		pad1Up = (1 << Display.KEY_RIGHT);
		pad1Down = (1 << Display.KEY_LEFT);
		pad1Left = (1 << Display.KEY_UP);
		pad1Right = (1 << Display.KEY_DOWN);
		
		keyUp = (1 << Display.KEY_RIGHT);
		keyDown = (1 << Display.KEY_LEFT);
		keyOK = (1 << Display.KEY_SELECT);
		keyCancel = (1 << Display.KEY_UP);
	}
	
	public static boolean load(){
		DataInputStream input = null;
		try {
			input = Connector.openDataInputStream("scratchpad:///0;pos=0");
			if (!(input.readChar() == 'C'
				&& input.readChar() == 'O'
				&& input.readChar() == 'N'
				&& input.readChar() == 'F')) {
				return false;
			}
			pad1A = input.readInt();
			pad1B = input.readInt();
			pad1Select = input.readInt();
			pad1Start = input.readInt();
			pad1Up = input.readInt();
			pad1Down = input.readInt();
			pad1Left = input.readInt();
			pad1Right = input.readInt();
			keyStateSave = input.readInt();
			keyStateLoad = input.readInt();
			keyUp = input.readInt();
			keyDown = input.readInt();
			keyOK = input.readInt();
			keyCancel = input.readInt();
			keyMenu = input.readInt();
			frameSkip = input.readInt();
			sleepEnable = input.readBoolean();
			vSyncWaitEnable = input.readBoolean();
			dispFPSEnable = input.readBoolean();
			APUMode = input.readInt();
			APUVolume = input.readInt();
			APUBuffer = input.readInt();
			APUEnable = input.readBoolean();
			APUStereoEnable = input.readBoolean();
		} catch (IOException e) {
			e.printStackTrace();
			return false;
		} finally {
			try {
				input.close();
			} catch (IOException e) {
				e.printStackTrace();
				return false;
			}
		}
		return true;
	}
	
	public static boolean save(){
		DataOutputStream output = null;
		try {
			output = Connector.openDataOutputStream("scratchpad:///0;pos=0");
			output.writeChars("CONF");
			output.writeInt(pad1A);
			output.writeInt(pad1B);
			output.writeInt(pad1Select);
			output.writeInt(pad1Start);
			output.writeInt(pad1Up);
			output.writeInt(pad1Down);
			output.writeInt(pad1Left);
			output.writeInt(pad1Right);
			output.writeInt(keyStateSave);
			output.writeInt(keyStateLoad);
			output.writeInt(keyUp);
			output.writeInt(keyDown);
			output.writeInt(keyOK);
			output.writeInt(keyCancel);
			output.writeInt(keyMenu);
			output.writeInt(frameSkip);
			output.writeBoolean(sleepEnable);
			output.writeBoolean(vSyncWaitEnable);
			output.writeBoolean(dispFPSEnable);
			output.writeInt(APUMode);
			output.writeInt(APUVolume);
			output.writeInt(APUBuffer);
			output.writeBoolean(APUEnable);
			output.writeBoolean(APUStereoEnable);
		} catch (IOException e) {
			e.printStackTrace();
			return false;
		} finally {
			try {
				output.close();
			} catch (IOException e) {
				e.printStackTrace();
				return false;
			}
		}
		return true;
	}
}
