import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

class PAD {
	private boolean[] keyState;

	private int readCountPad1;

	private int readCountPad2;

	private int resetCount;

	PAD() {
		this.keyState = new boolean[8];
		this.readCountPad1 = 0;
		this.readCountPad2 = 0;
		this.resetCount = 0;
	}

	public void ReadKeys(int keys) {
		// ǂݍ	Ή{^
		// 1		B
		// 2		SELECT
		// 3		START
		// 4		
		// 5		
		// 6		
		// 7		E
		// 0		A
		keyState[0] = (keys & Config.pad1A) != 0;
		keyState[1] = (keys & Config.pad1B) != 0;
		keyState[2] = (keys & Config.pad1Select) != 0;
		keyState[3] = (keys & Config.pad1Start) != 0;
		keyState[4] = (keys & Config.pad1Up) != 0;
		keyState[5] = (keys & Config.pad1Down) != 0;
		keyState[6] = (keys & Config.pad1Left) != 0;
		keyState[7] = (keys & Config.pad1Right) != 0;
	}
	
	/**
	 * 1P̃pbh́i$4016j
	 * @return
	 */
	public int GetPad1() {
		int ret = 0;
		if (keyState[readCountPad1]) {
			ret = 0x41;
		}
		readCountPad1++;
		if (readCountPad1 > 7) {
			readCountPad1 = 0;
		}
		return ret;
	}

	public void SetPad1(int value) {
		if (value == 0x01) {
			resetCount = 1;
		} else if (value == 0x00 && resetCount == 1) {
			readCountPad1 = 0;
			readCountPad2 = 0;
		}
	}

	/**
	 * 2P̃pbh́i$4017j
	 * @return
	 */
	public int GetPad2() {
		int ret = 0;
		if (keyState[readCountPad2]) {
			ret = 0x41;
		}
		readCountPad2++;
		if (readCountPad2 > 7) {
			readCountPad2 = 0;
		}
		return ret;
	}
	
	public void stateLoad(DataInputStream input) throws IOException {
		readCountPad1 = input.readUnsignedByte();
		readCountPad2 = input.readUnsignedByte();
		resetCount = input.readUnsignedByte();
	}
	  
	public void stateSave(DataOutputStream output) throws IOException {
		output.writeByte(readCountPad1);
		output.writeByte(readCountPad2);
		output.writeByte(resetCount);
	}

}
